//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// PlayGui is the main TSControl through which the game is viewed.
// The PlayGui also contains the hud controls.
//-----------------------------------------------------------------------------

function PlayGui::onWake(%this)
{
   // Turn off any shell sounds...
   // alxStop( ... );

   $enableDirectInput = "1";
   activateDirectInput();

   // Message hud dialog
   Canvas.pushDialog( MainChatHud );
   chatHud.attach(HudMessageVector);

   // just update the action map here
   moveMap.push();
   
   // hack city - these controls are floating around and need to be clamped
   schedule(0, 0, "refreshCenterTextCtrl");
   schedule(0, 0, "refreshBottomTextCtrl");
}

function PlayGui::onSleep(%this)
{
   Canvas.popDialog( MainChatHud  );
   
   // pop the keymaps
   moveMap.pop();
}


//-----------------------------------------------------------------------------

function refreshBottomTextCtrl()
{
   BottomPrintText.position = "0 0";
}

function refreshCenterTextCtrl()
{
   CenterPrintText.position = "0 0";
}


function clientCmdSetAmmoHudBow(%value)
{
    if (%value == 0) BowAmount.setText("");
	else BowAmount.setText("" @ %value);
}

// Rest of ammo
function clientCmdSetAmmoHudBall(%value)
{
    if (%value == 0) { BallAmount.setText("Hold F to reload"); }
	else BallAmount.setText("" @ %value);
}

function clientCmdSetAmmoHudSlush(%value)
{
    if (%value == 0) SlushAmount.setText("");
	else SlushAmount.setText("" @ %value);
}
function clientCmdSetAmmoHudRock(%value)
{
    if (%value == 0) RockAmount.setText("");
	else RockAmount.setText("" @ %value);
}


