// SSD: MissionTrigger is used to create mission loading points
datablock TriggerData(MissionTrigger)
{
   // The period is value is used to control how often the console
   // onTriggerTick callback is called while there are any objects
   // in the trigger.  The default value is 100 MS.
   tickPeriodMS = 100;
};

//-----------------------------------------------------------------------------

function MissionTrigger::onEnterTrigger(%this,%trigger,%obj)
{
   // This method is called whenever an object enters the %trigger
   // area, the object is passed as %obj.  The default onEnterTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,1) method on
   // every object (whatever it's type) in the same group as the trigger.

   
    if ($Server::MissionFile $= "starter.fps/data/missions/school.mis")
		{ echo ("SCHOOL KILL COUNT   " @ $Game::killCount);
		  
		if ($Game::killCount >= 7) 
		     { if (%obj.getClassName() $= "Player") {
				   %obj.savePersistentData();
                   LaunchMission( %trigger.missionToLoad, %trigger.destinationSpawnPoint ); }
			 }
		}
   else if ($Server::MissionFile $= "starter.fps/data/missions/mcgreary.mis")	
        {  if (%obj.getClassName() $= "Player") {
				%obj.savePersistentData();
				LaunchMission( %trigger.missionToLoad, %trigger.destinationSpawnPoint ); }
		}   
   else if ($Server::MissionFile $= "starter.fps/data/missions/pond.mis")
		{  if (%obj.getClassName() $= "Player") {
				%obj.savePersistentData();
				$Game::killCount = 0;
				LaunchMission( %trigger.missionToLoad, %trigger.destinationSpawnPoint ); }
        }
   else if ($Server::MissionFile $= "starter.fps/data/missions/culdesac.mis")
		{ echo ("CULDESAC KILL COUNT   " @ $Game::killCount);
		if ($Game::killCount >= 5)
			{  if (%obj.getClassName() $= "Player") {
					%obj.savePersistentData();
					loadVictoryFlash("./victory.jpg"); }
		}
		}
   
   echo("HERE WE ARE TRYING TO LOAD A NEW LEVEL.");
   Parent::onEnterTrigger(%this,%trigger,%obj);
   
   // SSD: only launch the mission if this is the player object

}

function MissionTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
   // This method is called whenever an object leaves the %trigger
   // area, the object is passed as %obj.  The default onLeaveTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,0) method on
   // every object (whatever it's type) in the same group as the trigger.
   //error("on leave trigger: " @ %trigger);
   Parent::onLeaveTrigger(%this,%trigger,%obj);
}

function MissionTrigger::onTickTrigger(%this,%trigger)
{
   // This method is called every tickPerioMS, as long as any
   // objects intersect the trigger. The default onTriggerTick
   // method (in the C++ code) invokes the ::onTriggerTick(%trigger) method on
   // every object (whatever it's type) in the same group as the trigger.

   // You can iterate through the objects in the list by using these
   // methods:
   //    %this.getNumObjects();
   //    %this.getObject(n);
   //error("on tick trigger: " @ %trigger);
   Parent::onTickTrigger(%this,%trigger);
}

//Eric Morata / Tom Spilman resource
//this triggerdata and function must be cretated
// for every exit that connects to a specifc spawnsphere.
//in this case, you'll be sent to $scene0, in the spawnpoint named "spawnsphere_name"
//Tom Spilman code snipet
// Launches another %mission after %timeout milliseconds at
// the %spawn point desired.  %timeout and %spawn can be zero.
function LaunchMission( %mission, %spawn, %timeout )
{   
   if ( !$Game::LaunchingMission ) {
      $Game::NextMission = %mission;
	  $Game::NextSpawn = %spawn;
	  $Game::LaunchingMission = true;
	  schedule( %timeout, 0, "onLaunchMission" );
   }
}

function onLaunchMission()
{
   $Game::LaunchingMission = false;
   loadMission( $Game::NextMission );
}
//-------------
